-- INFORMIX Dynamic 4GL Demonstration
--
-- @(#)$Id: d4_export.4gl,v 1.5 1998/08/04 23:18:47 jleffler Exp $
--
-- $Product: INFORMIX Dynamic 4GL Demonstration Version 2.00.UC8 (1998-08-25) $

--# USE CHANNEL
--#
--# GLOBALS "d4_globals.4gl"
--#
--# FUNCTION export_it()
--#
--#     DEFINE filename CHAR(20)
--#     DEFINE delim    CHAR(1)
--#     DEFINE flag     SMALLINT
--#     DEFINE otherd   CHAR(1)
--#     DEFINE answer   CHAR(1)
--#     DEFINE mname    CHAR(15)
--#     DEFINE descr    CHAR(15)
--#     DEFINE tsum2    MONEY
--#     DEFINE iflag    INTEGER
--#     DEFINE fmess    CHAR(100)
--#
--#     OPEN WINDOW ex_win AT 8,20 WITH FORM "export_it"
--#                                      ATTRIBUTE(BORDER, FORM LINE 1)
--#
--#     LET flag     = 0
--#     LET answer   = "N"
--#     LET filename = ""
--#     LET otherd   = ""
--#     LET delim    = "|"
--#     LET iflag    = 0
--#
--#     WHILE (answer = "N")
--#
--#         INPUT BY NAME filename, delim, otherd WITHOUT DEFAULTS
--#         BEFORE INPUT
--#             CALL dialog.keysetlabel("Control-o", "")
--#         ON KEY (CONTROL-O)
--#             LET flag = 1
--#             NEXT FIELD otherd
--#         BEFORE FIELD otherd
--#             IF flag = 0 THEN
--#                 NEXT FIELD filename
--#             END IF
--#         ON KEY (INTERRUPT)
--#             LET iflag = 1
--#             LET answer = "Y"
--#             EXIT INPUT
--#         AFTER INPUT
--#             LET answer = "Y"
--#         END INPUT
--#
--#         IF (LENGTH(filename) = 0 OR filename = NULL) AND iflag = 0 THEN
--#             CALL fgl_winquestion("Yes/No?",
--#                 "Would you like to print the results to the calling screen?",
--#                 "No", "Yes|No", "question", 0)
--#                  RETURNING answer
--#         END IF
--#
--#     END WHILE
--#
--#     IF INT_FLAG THEN
--#         LET INT_FLAG = 0
--#         RETURN
--#     END IF
--#
--#     IF iflag = 0 THEN
--#
--#         IF flag = 1 THEN
--#             LET delim = otherd
--#         END IF
--#
--#         CALL channel::open_file("file1", filename, "w")
--#         CALL channel::set_delimiter("file1", delim)
--#
--#         PREPARE p_sel FROM "select * from t1"
--#         DECLARE ex_curs CURSOR FOR p_sel
--#
--#         FOREACH ex_curs INTO mname, descr, tsum2
--#             CALL channel::write("file1", [mname, descr, tsum2])
--#         END FOREACH
--#
--#         CALL channel::close("file1")
--#
--#     END IF
--#
--#     CLOSE WINDOW ex_win
--#
--#     IF iflag = 0 THEN
--#
--#         IF (LENGTH(filename) = 0 OR filename = NULL) THEN
--#             LET filename = "standard output"
--#         END IF
--#         LET fmess = "The result has been written to ", filename CLIPPED,
--#                        " using the delimiter '", delim CLIPPED, "'"
--#         CALL fgl_winmessage("Write Complete", fmess, "info")
--#
--#     END IF
--#
--# END FUNCTION {export_it}
