{
$Id: ia_input.4gl,v 1.1.1.1 1998/07/21 10:27:53 rene Exp $
}
define t record 
  f1,f2 char(20),
  f3 float,
  f4 decimal(10,2),
  f5 char(1)
end record 

function test_input_form()
  define f1 integer
  open form tif from "ia_input1"
  display form tif
  input by name f1
  close form tif
end function

function test_input()  
  define m char(80)
  define ww char(500)
--  open window test_input at 2,2 with form "ia_input" 
--    attribute(border)
  open window test_input at 2,2 with 22 rows,78 columns
    attribute(border)
  open form test_input from "ia_input" 
  display form test_input 

  let t.f1 = "f1"
  let t.f2 = "f2"
  let t.f3 = "10.123"
  let t.f4 = "10.12"
  let t.f5 = "5"

--goto dummy
  menu "Input"
  command "Options"
    menu "Options"  
    command "red"     options input attribute(red) exit menu
    command "green"   options input attribute(green) exit menu
    command "blue"    options input attribute(blue) exit menu
    command "cyan"    options input attribute(cyan) exit menu
    command "white"   options input attribute(white) exit menu
    command "normal"  options input attribute(normal) exit menu
    command "no wrap" OPTIONS INPUT NO WRAP
    command "wrap"    OPTIONS INPUT WRAP
    command "end"    exit menu
    end menu
  command "input" 
   "INPUT t.* FROM t.*"
    input t.* from t.*
    on key(f12) call test_input_form() 
    on key(f11) call test_input_form() display form test_input 
    on key(f10) 
--#      let m="<",dialog.getBuffer() clipped,">"
      error m
--#      call dialog.setBuffer(m)
    on key(f5) 
      display "hallo" to info[1].infoline
      current window is screen
      display "hallo" to f1
    end input
  command "* disp/input" 
   "display by name t.* attribute(reverse); INPUT by name t.*"
    display by name t.* attribute(reverse); INPUT by name t.* 
  command "d ww"
    display "hallo das ist ein ww test" to ww
  command "wordwrap"
    input by name ww
  command "disp" 
   "display by name t.*"
  command "np without def" 
   "INPUT t.* WITHOUT DEFAULTS from t.* attribute(magenta)"
    input t.* without defaults from t.* attribute(magenta)
  command "inp by name" 
   "INPUT by name t.*"
    input by name t.*
  command "4" 
   "INPUT by name t.* WITHOUT DEFAULTS"
    input by name t.* without defaults
  command "error" "provocate some errors"
whenever error continue
  menu "ERROR"
    command "nextfield" 
      input by name t.* without defaults
      after field f1 next field fff1
      end input
      call err_print(status)
    command "fldbuff" 
      input by name t.* without defaults
      after field f1 
        if get_fldbuf(non) then end if
        continue input
      end input
      call err_print(status)
    command "field_touched" 
      input by name t.* without defaults
      after field f1 
        if field_touched(non) then end if
        continue input
      end input
      call err_print(status)
    command "end" 
      exit menu
  end menu 
whenever error stop
  command "d1" "Debug"                   call do_input()
  command "d2" "Debug,Tasten ueberladen" call do_input2()
  command "i"
    "init"
    let t.f1 = "f1"
    let t.f2 = "f2"
    let t.f3 = "f3"
    let t.f4 = "f4"
    let t.f5 = "5"
    display by name t.*
  command "list" "input from a list"
    menu "List"
    command "from list.*" 
     "INPUT t.* from l.*"
      input t.* from l.*
      on key(f12) call test_input_form() on key(f11) call test_input_form() display form test_input 
      end input
    command "from list[2].*" 
     "INPUT t.* form l[2].*"
      input t.* from l[2].*
      on key(f12) call test_input_form() on key(f11) call test_input_form() display form test_input 
      end input
    command "list"
     input t.f1,t.f2,t.f3 from l[1].l1, l[2].l1, l[3].l1
    command "Z1" 
     "Zweizeilige Liste: INPUT t.* form z.*"
      input t.* from z.*
      on key(f12) call test_input_form() on key(f11) call test_input_form() display form test_input 
      end input
    command "Z2" 
     "Zweizeilige Liste: t.* form z[2].*"
      input t.* from z[2].*
      on key(f12) call test_input_form() on key(f11) call test_input_form() display form test_input 
      end input
    command "end" 
      exit menu
    end menu
  command "form line"
    "Formline"
    call form_line()
  command "Labels"
    menu "LABELS"
    command "default" "default labels"
      input by name t.*
      on key(f3)
      on key(f4)
      end input
    command "1" "f3=<key f3> f4=<key f4>"
      input by name t.*
      on key(f3)
      on key(f4)
      before input
--        call dialog.keySetLabel("f3","<key f4>")
--        call dialog.keySetLabel("f4","<key f4>")
      end input
    command "End" 
      exit menu
    end menu
  command "End" 
    exit menu
  end menu
  close window test_input
  OPTIONS INPUT NO WRAP
end function

function form_line()
  open window input_3 at 3,3  with form "ia_input1"
    attribute(border, form line 5, comment line 1, message line 2)
    sleep(1)
  close window input_3
end function

function do_input2()
  define action integer
  define msg char(20)
  call info_init()
  input t.* from t.*
  before input            call info("BI")
  on key (escape)         call info("escape")
  on key (control-b)      call info("^B")
  on key (return)         call info("return")
  on key (up)             call info("up")
  on key (down)           call info("down")
  on key (F2) 	          call info("f2")
  on key (F3) 	          call info("F3")
  on key (F4) 	          call info("F4")
  on key (F5,f6,f7,f8)    call info("F5..F8")
  on key (F9,f10,f11,f12) call info("F9..F12")
  on key (insert,delete,nextpage,prevpage) 	
                          call info("virtual")
  on key (INTERRUPT) 	  call info("INTERRUPT")
  before field f1 	  call info("b1")
  after  field f1 	  call info("a1")
  before field f2 	  call info("b2")
  after  field f2 	  call info("a2") 
  after  field f3,f4 	  call info("a3/a4")
  before field f3,f4 	  call info("b3/a4")
  after input      	
    menu "after input"
    command "exit"         let action=0 exit menu
    command "continue"     let action=1 exit menu
    command "nextfield f2" let action=2 exit menu
    command "nextfield f4" let action=3 exit menu
    command "NOP"          let action=-1 exit menu
    end menu
    case action
      when 0 exit input
      when 1 continue input
      when 2 next field f2
      when 3 next field f4
    end case
  end input
  error "INT_FLAG:",int_flag
end function

function do_input()
  define action integer
  define msg char(20)
  call info_init()
  input t.* from t.*
  before input            call info("BI")
  on key (control-g)      call info("^g") 
  on key (control-w)      call info("^w") 
  on key (control-z)      call info("^z") 
  on key (F2) 	          call info("f2") call form_line() 
  on key (F3) 	          message "message f3" call info("F3")
  on key (F4) 	          call info("F4")
  on key (F5,f6,f7,f8)    call info("F5..F8")
    error "f3:",t.*   
  on key (F9,f10,f11,f12) call info("F9..F12")
  before field f1 	  call info("b1")
  after  field f1 	  call info("a1")
  before field f2 	  call info("b2")
  after  field f2 	  call info("a2") 
  after  field f3,f4 	  call info("a3/a4")
  before field f3,f4 	  call info("b3/a4")
  after input      	
    menu "after input"
    command "exit"         let action=0 exit menu
    command "continue"     let action=1 exit menu
    command "nextfield f2" let action=2 exit menu
    command "nextfield f4" let action=3 exit menu
    command "NOP"          let action=-1 exit menu
    end menu
    case action
      when 0 exit input
      when 1 continue input
      when 2 next field f2
      when 3 next field f4
    end case
  end input
  error "INT_FLAG:",int_flag
end function

