#------------------------------------------------------------------------
# Compagny	:	4Js
# Developper	:	PM
# Program	:	$PROJET/stdparam.tcl
# Date		:	16.05.95
# Title		:	Definition of standard parameters. It is
#			highly recommended to conserve one version of it,
#			and never lose it ...
# FGLGUI=	unset or 0	Ascii -text
#			1	X
#			2	Undefined
#			3	Undefined
#			4	Ms-Windows
#------------------------------------------------------------------------

global _STDPARAM
global env
set _STDPARAM "OK"

#puts stderr " ========= SOURCING  STDPARAM  =========== "

if { ! [info exists env(FGLDESI)] } {
  set env(FGLDESI) "$env(FGLDIR)/desi/oprojet"
  } 

#puts stderr "FGLGUI is set to $fglgui"

if {$fglgui == 1} {
  set bitmapExt "xbm"
} else {
  set bitmapExt "bmp"
  }

set tkOrgButtons    1
set tkOrgEntrys     1
set tkOrgLabels     1
set tkOrgScrollbars 1

if { ! [info exists env(FGLDIR)] } {
  if { $fglgui == 4 } {
      set env(FGLDIR) "/wtkclt"
    } else {
      set env(FGLDIR) "/usr/fgl2c"
    }
  } 


set Default(Bitmap,Quit)	"\@$env(FGLDESI)/images/quit.$bitmapExt"
set Default(Bitmap,Load)	"\@$env(FGLDESI)/images/load.$bitmapExt"
set Default(Bitmap,Save)	"\@$env(FGLDESI)/images/save.$bitmapExt"
set Default(Bitmap,Info)	"info"
set Default(Bitmap,Questhead)	"questhead"
set Default(Bitmap,Button)	"\@$env(FGLDESI)/images/button.$bitmapExt"
set Default(Bitmap,Entry)	"\@$env(FGLDESI)/images/entry.$bitmapExt"
set Default(Bitmap,Field)	"\@$env(FGLDESI)/images/field.$bitmapExt"
set Default(Bitmap,Array)	"\@$env(FGLDESI)/images/array.$bitmapExt"
set Default(Bitmap,Label)	"\@$env(FGLDESI)/images/label.$bitmapExt"

set Default(Offset,X)		8
set Default(Offset,Y)		32
set Default(Offset,Height)	30
set Default(Offset,Width)	10

set Default(Widget,PadX)	1
set Default(Widget,PadY)	1
set Default(Widget,Relief)	flat
set Default(Widget,BorderWidth)	2
set Default(Widget,Bg)		$Default(Color,LightCyan3)
set Default(Widget,Fg)		$Default(Color,black)
#set Default(Widget,Fg)		$Default(Color,LightCyan1)
set Default(Widget,SelectedBg)	$Default(Color,LightCyan1)
set Default(Widget,ActiveBg)	$Default(Color,LightCyan2)
set Default(Widget,ActiveFg)	$Default(Color,white)

set Default(Toplevel,Relief)	flat
set Default(Toplevel,Width)	150
set Default(Toplevel,Height)	200

set Default(Container,Width)	0
set Default(Container,Height)	0
set Default(Container,Relief)	raised
set Default(Container,PadX)	1
set Default(Container,PadY)	1

set Default(Attributlist,PadX)	0
set Default(Attributlist,PadY)	0

set Default(Field,Relief)	groove
set Default(Field,Width)	0
set Default(Field,Height)	0
set Default(Field,PadX)		1
set Default(Field,PadY)		1
set Default(Field,IntPadX)	1
set Default(Field,IntPadY)	1
set Default(Field,BorderWidth)	2

set Default(Array,Relief)	groove
set Default(Array,Bg)		$Default(Widget,Bg)	
set Default(Array,Width)	200
set Default(Array,Height)	150

set Default(Title,Relief)	ridge
set Default(Title,PadX)		6m
set Default(Title,PadY)		3m

set Default(Button,BWidth)	45	;#	Button with bitmap
set Default(Button,BHeight)	25	;#		"
set Default(Button,TWidth)	10	;#	Button with text
set Default(Button,THeight)	1	;#		"
set Default(Button,ActiveBg)	$Default(Color,LightCyan2)
set Default(Button,Bg)		$Default(Color,LightCyan3)
set Default(Button,Relief)	raised

set Default(Radio,Relief)	flat
set Default(Radio,DisabledFg)	gray60

set Default(Check,Relief)	flat
set Default(Check,DisabledFg)	gray60

set Default(Label,Width)	0
set Default(Label,Height)	1
set Default(Label,Bg)		$Default(Color,LightCyan3)
set Default(Label,Relief)	flat

set Default(Entry,Width)	20
set Default(Entry,Height)	10
set Default(Entry,Relief)	sunken
set Default(Entry,Bg)		$Default(Color,LightCyan3)
set Default(Entry,Bg)		gray90
set Default(Entry,ActiveBg)	$Default(Color,LightCyan2)
set Default(Entry,ActiveBg)	gray95
set Default(Entry,SelectedBg)	$Default(Color,LightCyan1)
set Default(Entry,SelectedBg)	white
set Default(Entry,HighlightBg)	gray40
set Default(Entry,ReverseBg)	$Default(Color,LightCyan4)
set Default(Entry,ReverseBg)	gray60

set Default(Entry,SelectedFg)	black
set Default(Entry,SelectedBw)	2
set Default(Entry,Fg)		black

set Default(Canvas,Relief)      "sunken"
set Default(Canvas,BorderWidth) 1
set Default(Canvas,Bg) 		$Default(Color,LightCyan3)

set Default(Form,Width)		500
set Default(Form,Height)	400
set Default(Form,Relief)	raised

set Default(Menu,Width)		200
set Default(Menu,Height)	200
set Default(Menu,Relief)	flat

set Default(Resources,Width)	200
set Default(Resources,Height)	200
set Default(Resources,Bg)	CadetBlue3

set Default(Desi,Width)		700
set Default(Desi,Height)	400
set Default(Desi,EWD)		5	;# Entry Width Divider



